Using Mobiscroll components as ES6 modules
Mobiscroll components are defined as ES6 modules with dependencies defined, so they can be used as such. The advantage of this is that you don't need to build your Mobiscroll package manually, you include the full source code in your application and import the necessary components in your source code. When your application is built, only the source code of the imported components (and their dependencies) will be included in the bundle.
Depending on which framework you use for your project, there are differences on how to set up the ES6 modules. Please choose your framework below and follow the instructions in the example.
Choose example
Example CLI App for Angular
Prerequisites
        To demonstrate the usage of the ES6 modules we will use the angular cli to create an app.
        The Mobiscroll source code can be downloaded from the download page, selecting the uncompressed version.
    
This guide assumes you have the angular cli installed. If not, visit the angular docs on how to get started with angular.
When creating your app please select the SCSS stylesheet format when prompted (starting from version 4.7.0 the Mobiscroll stylesheets are written in SCSS - but more on that later). 
The following command will create the angular app:
ng new my-appSetting up the App
        After the app is createad, the js, scss and fonts folders have to be extracted and copied over from the downloaded package to the src/lib/mobiscroll folder of your app.
        Make sure the existing folder structure is kept. Here's how the app structure should look after the setup:
    
/
|--e2e
|--node_modules
|--src/
  |--app
    |--app.component.html
    |--app.component.ts
    |--app.module.ts
  |--assets
  |--environment
  |--lib
    |--mobiscroll
      |--fonts
      |--js
      |--scss
  |--index.html
  |--styles.scss
|--package.json
|--tsconfig.json
*Above are shown only the files and folders that are most relevant to this guide.
Paths shortcut
The following addition to the tsconfig.json file will make the mobiscroll module paths more simple.
{
  "compileOnSave": false,
  "compilerOptions": {
    "paths": {
      "@mobiscroll/*": [
        "src/lib/mobiscroll/js/*"
      ]
    },
    // ... 
  }
}Adding the path to the js folder in compilerOptions, will enable the use of '@mobiscroll' shortcut instead of the whole relative paths.
Mobiscroll Modules
        All of the mobiscroll controls have a module for them. For example all that's related to the calendar, like the <mbsc-calendar> component or the [mbsc-calendar] directive, are located in the MbscCalendarModule. So when a component needs to be used inside a module, the module of that component has to be imported and added to the imports array.
    
        For example, to use the calendar component in the app.component, the MbscCalendarModule has to be imported and added to the app.module.ts.
        The same is true for the Mobiscroll Form. Here's how to load both modules:
    
import { MbscCalendarModule } from '@mobiscroll/calendar.angular';
import { MbscFormsModule } from '@mobiscroll/forms.angular';
@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    MbscCalendarModule,
    MbscFormsModule
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }
<mbsc-form>
    <mbsc-calendar>My Birthday</mbsc-calendar>
</mbsc-form>Mobiscroll is built using JavaScript, HTML and CSS. For the JavaScript (TypeScript in this case) and HTML part this will do just fine, but the components also need the stylesheets.
Styles
The Mobiscroll styles are located in the scss folder and they need to be imported in the global styles, in order for them to be applied.
For the above example, we need to load the styles for the calendar and the forms. For each theme that is included in the package, there is a file in the component's folder with the name of the component and the theme. In this example we will import two themes, the mobiscroll and the ios theme:
/* You can add global styles to this file, and also import other style files */
/* Import Mobiscroll component styles for each theme */
@import 'lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import 'lib/mobiscroll/scss/calendar/calendar.ios';
@import 'lib/mobiscroll/scss/forms/forms.mobiscroll';
@import 'lib/mobiscroll/scss/forms/forms.ios';
The icons required for the package are located in the fonts folder. There's an scss variable that needs to be set to find the font, and it's called $mbsc-font-path
/* Set the font path first */
/* Use the following font path in case of, angular 9 and below */
$mbsc-font-path: 'lib/mobiscroll/fonts/';
/* Use the following font path in case of angular 10 and up */
$mbsc-font-path: '~/lib/mobiscroll/fonts/';
/* Import Mobiscroll component styles for each theme */
@import 'lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import 'lib/mobiscroll/scss/calendar/calendar.ios';
@import 'lib/mobiscroll/scss/forms/forms.mobiscroll';
@import 'lib/mobiscroll/scss/forms/forms.ios';
At this point building and running the app, should work, and the mobiscroll components should show up using the default mobiscroll theme.
        To use the auto-theme and/or custom built themes, they also need to be loaded.
        Light or dark variants of the themes (ios-dark, material-dark,
        mobiscroll-dark) are present in the scss/themes folder and contain the colors 
        for all the components so only one scss file needs to be imported. The same applies for custom themes built with the Theme Builder.
        The themes have JavaScript parts too, so the scripts need to be imported as well.
    
        Languages should be loaded from the i18n folder of the Mobiscroll source.
    
        Here's an example how to load and use Spanish and Italian languages and ios, material and auto themes.
 Also their dark variants, and a custom theme called "my-custom-theme", that's built with the themebuilder.    
import { MbscCalendarModule } from '@mobiscroll/calendar.angular';
import { MbscFormsModule } from '@mobiscroll/forms.angular';
// import languages
import '@mobiscroll/i18n/es.js';
import '@mobiscroll/i18n/it.js';
// import themes (note: order matters, auto-theme should be the last one)
import '@mobiscroll/themes/ios.js';
import '@mobiscroll/themes/ios-dark.js';
import '@mobiscroll/themes/material.js';
import '@mobiscroll/themes/material-dark.js';
import '@mobiscroll/themes/my-custom-theme.js';
import '@mobiscroll/themes/auto-theme.js';
Import the scss files for the themes:
/* You can add global styles to this file, and also import other style files */
/* Import Mobiscroll component styles */
@import 'lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import 'lib/mobiscroll/scss/calendar/calendar.ios';
@import 'lib/mobiscroll/scss/calendar/calendar.material';
@import 'lib/mobiscroll/scss/forms/forms.mobiscroll';
@import 'lib/mobiscroll/scss/forms/forms.ios';
@import 'lib/mobiscroll/scss/forms/forms.material';
/* Import theme variants */
@import 'lib/mobiscroll/scss/themes/mobiscroll-dark';
@import 'lib/mobiscroll/scss/themes/ios-dark';
@import 'lib/mobiscroll/scss/themes/material-dark';
/* Import custom themes */
@import 'lib/mobiscroll/scss/themes/my-custom-theme';
At this point the app can be built and served using the angular cli. Styles will be applied automatically depending on the device the app is being ran on.
ng serveExample CLI App for Ionic v3
Prerequisites
        To demonstrate the usage of the ES6 modules we will use an ionic project.
        The Mobiscroll source code can be downloaded from the download page, selecting the uncompressed version.
    
This guide assumes you have the ionic cli installed. If not, visit the ionic docs on how to get started with ionic.
        When creating the app, please select the tabs boilerplate. There's no need for the Ionic Appflow SDK, so when it's prompted, select no.
        The following command will create the ionic app:
    
ionic start my-appSetting up the App
            After the app is created, you need to copy over the extracted mobiscroll package to the project. The js and scss folders should go under the src/lib/mobiscroll folder of the project.
            The fonts folder should go under the src/assets/. Make sure the existing folder structure is kept. Here's how the app structure should look after the setup:
        
/
|--node_modules
|--src/
  |--app
    |--app.component.ts
    |--app.html
    |--app.module.ts
    |--app.scss
    |--main.ts
  |--assets
    |--fonts
      |--icons_mobiscroll.ttf
      |--icons_mobiscroll.woff
    |--icon
  |--lib
    |--mobiscroll
      |--js
      |--scss
  |--pages
  |--theme
  |--index.html
|--package.json
|--tsconfig.json
*Above are shown only the files and folders that are most relevant to this guide.
Mobiscroll Modules
        All of the mobiscroll controls have a module for them. For example all that's related to the calendar, like the <mbsc-calendar> component or the [mbsc-calendar] directive, are located in the MbscCalendarModule. So when a component needs to be used inside a module, the module of that component has to be imported and added to the imports array.
    
        For example, to use the calendar component in the home page component, the MbscCalendarModule has to be imported and added to the app.module.ts.
        The same is true for the Mobiscroll Form. Here's how to load both modules:
    
import { MbscCalendarModule } from '../lib/mobiscroll/js/calendar.angular';
import { MbscFormsModule } from '../lib/mobiscroll/js/forms.angular';
@NgModule({
  declarations: [
    MyApp,
    AboutPage,
    ContactPage,
    HomePage,
    TabsPage
  ],
  imports: [
    BrowserModule,
    MbscCalendarModule, // added
    MbscFormsModule, // added
    IonicModule.forRoot(MyApp)
  ],
  // ...
<ion-header>
  <ion-navbar>
    <ion-title>Home</ion-title>
  </ion-navbar>
</ion-header>
<ion-content padding>
  <mbsc-form>
    <mbsc-calendar>My Birthday</mbsc-calendar>
  </mbsc-form>
</ion-content>Mobiscroll is built using JavaScript, HTML and CSS. For the JavaScript (TypeScript in this case) and HTML part this will do just fine, but the components also need the stylesheets.
Styles
The Mobiscroll styles are located in the scss folder and starting from version 4.7.0 they are written in SCSS. The styles needs to be imported in the global app.scss in order to work.
For the above example, we need to load the styles for the calendar and the forms. For each theme that is included in the package, there is a file in the component's folder with the name of the component and the theme. In this example we will import two themes, the mobiscroll and the ios theme:
/* Import Mobiscroll component styles for each theme */
@import '../lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import '../lib/mobiscroll/scss/calendar/calendar.ios';
@import '../lib/mobiscroll/scss/forms/forms.mobiscroll';
@import '../lib/mobiscroll/scss/forms/forms.ios';
            The icons required for the package are located in the fonts folder.
            There's an scss variable that needs to be set to find the font, and it's called $mbsc-font-path.
            Remember that we copied the fonts to the assets folder, so that it will be copied over to the www folder, when the app is built.
            In this example the font path should be the following:
        
/* Set font path */
$mbsc-font-path: '/assets/fonts/';
/* Import Mobiscroll component styles for each theme */
@import '../lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import '../lib/mobiscroll/scss/calendar/calendar.ios';
@import '../lib/mobiscroll/scss/forms/forms.mobiscroll';
@import '../lib/mobiscroll/scss/forms/forms.ios';
            To use the auto-theme and/or custom built themes, they also need to be loaded.
            Light or dark variants of the themes (ios-dark, material-dark,
            mobiscroll-dark) are present in the scss/themes folder and contain the colors
            for all the components so only one scss file needs to be imported. The same applies for custom themes built with the Theme Builder.
            The themes have JavaScript parts too, so the scripts need to be imported as well.
        
            Languages should be loaded from the i18n folder of the Mobiscroll source.
        
            Here's an example how to load and use Spanish language and the ios, material and auto themes with
            dark variants and a custom theme named "my-custom-theme".
        
import { MbscCalendarModule } from '../lib/mobiscroll/js/calendar.angular';
import { MbscFormsModule } from '../lib/mobiscroll/js/forms.angular';
// import themes (order matters - auto-theme has to be the last one)
import '../lib/mobiscroll/js/themes/ios.js';
import '../lib/mobiscroll/js/themes/ios-dark.js';
import '../lib/mobiscroll/js/themes/material.js';
import '../lib/mobiscroll/js/themes/material-dark.js';
import '../lib/mobiscroll/js/themes/my-custom-theme.js';
import '../lib/mobiscroll/js/themes/auto-theme.js';
// import languages
import '../lib/mobiscroll/js/i18n/es.js';
import '../lib/mobiscroll/js/i18n/it.js';
Import the scss files for the themes:
/* Set font path */
$mbsc-font-path: '/assets/fonts/';
/* Import Mobiscroll component styles for each theme */
@import '../lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import '../lib/mobiscroll/scss/calendar/calendar.ios';
@import '../lib/mobiscroll/scss/calendar/calendar.material';
@import '../lib/mobiscroll/scss/forms/forms.mobiscroll';
@import '../lib/mobiscroll/scss/forms/forms.ios';
@import '../lib/mobiscroll/scss/forms/forms.material';
/* Import theme variants */
@import '../lib/mobiscroll/scss/themes/mobiscroll-dark';
@import '../lib/mobiscroll/scss/themes/ios-dark';
@import '../lib/mobiscroll/scss/themes/material-dark';
/* Import custom themes */
@import '../lib/mobiscroll/scss/themes/my-custom-theme';And done.
At this point, building and running the app with the mobiscroll package loaded should work.
ionic build
ionic serveExample CLI App for Ionic v4/5
Prerequisites
        To demonstrate the usage of the ES6 modules we will use an ionic project.
        The Mobiscroll source code can be downloaded from the download page, selecting the uncompressed version.
    
This guide assumes you have the ionic cli installed. If not, visit the ionic docs on how to get started with ionic.
        When creating the app, please select the tabs boilerplate. There's no need for the Ionic Appflow SDK, so when it's prompted, select no.
        The following command will create the ionic app:
    
ionic start my-appSetting up the App
        After the app is createad, the js, scss and fonts folders have to be extracted and copied over from the downloaded package to the src/lib/mobiscroll folder of your app.
        Make sure the existing folder structure is kept. Here's how the app structure should look after the setup:
    
/
|--node_modules
|--src/
  |--app
    |--tab1
      |--tab1.module.ts
      |--tab1.page.html
      ...
    |--tab2
    |--tab3
    |--tabs
    |--app-routing.module.ts
    |--app.component.html
    |--app.module.ts
    ...
  |--assets
  |--environments
  |--lib
    |--mobiscroll
      |--fonts
      |--js
      |--scss
  |--theme
  |--index.html
|--angular.json
|--package.json
*Above are shown only the files and folders that are most relevant to this guide.
Mobiscroll Modules
        All of the mobiscroll controls have a module for them. For example all that's related to the calendar, like the <mbsc-calendar> component or the [mbsc-calendar] directive, are located in the MbscCalendarModule. So when a component needs to be used inside a module, the module of that component has to be imported and added to the imports array.
    
        For example, to use the calendar component in the first tab, the tab1 component, the MbscCalendarModule has to be imported and added to the tab1.module.ts.
        The same is true for the Mobiscroll Form. Here's how to load both modules:
    
import { MbscCalendarModule } from '../../lib/mobiscroll/js/calendar.angular';
import { MbscFormsModule } from '../../lib/mobiscroll/js/forms.angular';
@NgModule({
  imports: [
    IonicModule,
    CommonModule,
    FormsModule,
    MbscCalendarModule,
    MbscFormsModule,
    RouterModule.forChild([{ path: '', component: Tab1Page }])
  ],
  declarations: [Tab1Page]
})
export class Tab1PageModule {}<ion-header>
  <ion-toolbar>
    <ion-title>
      Tab One
    </ion-title>
  </ion-toolbar>
</ion-header>
<ion-content padding>
    <mbsc-form>
      <mbsc-calendar>My Calendar</mbsc-calendar>
    </mbsc-form>
</ion-content>
Mobiscroll is built using JavaScript, HTML and CSS. For the JavaScript (TypeScript in this case) and HTML part this will do just fine, but the components also need the stylesheets.
Styles
The Mobiscroll styles are located in the scss folder and starting from version 4.7.0 they are written in SCSS. The styles needs to be imported in the global.scss in order to work.
For the above example, we need to load the styles for the calendar and the forms. For each theme that is included in the package, there is a file in the component's folder with the name of the component and the theme. In this example we will import two themes, the mobiscroll and the ios theme:
/* You can add global styles to this file, and also import other style files */
/* Import Mobiscroll component styles for each theme */
@import 'lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import 'lib/mobiscroll/scss/calendar/calendar.ios';
@import 'lib/mobiscroll/scss/forms/forms.mobiscroll';
@import 'lib/mobiscroll/scss/forms/forms.ios';
The icons required for the package are located in the fonts folder. There's an scss variable that needs to be set to find the font, and it's called $mbsc-font-path.
/* Set the font path first */
/* Use the following font path in case of ionic 4 and angular 9 and below */
$mbsc-font-path: 'lib/mobiscroll/fonts/';
/* Use the following font path in case of ionic 5 and angular 10 and up */
$mbsc-font-path: '~/lib/mobiscroll/fonts/';
/* Import Mobiscroll component styles for each theme */
@import 'lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import 'lib/mobiscroll/scss/calendar/calendar.ios';
@import 'lib/mobiscroll/scss/forms/forms.mobiscroll';
@import 'lib/mobiscroll/scss/forms/forms.ios';
        To use the auto-theme and/or custom built themes, they also need to be loaded.
        Light or dark variants of the themes (ios-dark, material-dark,
        mobiscroll-dark) are present in the scss/themes folder and contain the colors 
        for all the components so only one scss file needs to be imported. The same applies for custom themes built with the Theme Builder.
        The themes have JavaScript parts too, so the scripts need to be imported as well.
    
Here's an example how to load and use Spanish and Italian languages and ios, material and auto themes.
 Also with dark variants and a custom theme named "my-custom-theme".     
import { MbscCalendarModule } from '../../lib/mobiscroll/js/calendar.angular';
import { MbscFormsModule } from '../../lib/mobiscroll/js/forms.angular';
// import themes (order matters - auto-theme has to be the last one)
import '../../lib/mobiscroll/js/themes/ios.js';
import '../../lib/mobiscroll/js/themes/ios-dark.js';
import '../../lib/mobiscroll/js/themes/material.js';
import '../../lib/mobiscroll/js/themes/material-dark.js';
import '../../lib/mobiscroll/js/themes/my-custom-theme.js';
import '../../lib/mobiscroll/js/themes/auto-theme.js';
// import languages
import '../../lib/mobiscroll/js/i18n/es.js';
import '../../lib/mobiscroll/js/i18n/it.js';
Import the scss files for the themes:
/* You can add global styles to this file, and also import other style files */
/* Import Mobiscroll component styles */
@import 'lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import 'lib/mobiscroll/scss/calendar/calendar.ios';
@import 'lib/mobiscroll/scss/calendar/calendar.material';
@import 'lib/mobiscroll/scss/forms/forms.mobiscroll';
@import 'lib/mobiscroll/scss/forms/forms.ios';
@import 'lib/mobiscroll/scss/forms/forms.material';
/* Import theme variants */
@import 'lib/mobiscroll/scss/themes/mobiscroll-dark';
@import 'lib/mobiscroll/scss/themes/ios-dark';
@import 'lib/mobiscroll/scss/themes/material-dark';
/* Import custom themes */
@import 'lib/mobiscroll/scss/themes/my-custom-theme';And done.
At this point, building and running the app with the mobiscroll package loaded should work.
ionic build
ionic serve

Using Mobiscroll components as ES6 modules
Mobiscroll components are defined as ES6 modules with dependencies defined, so they can be used as such. The advantage of this is that you don't need to build your Mobiscroll package manually, you include the full source code in your application and import the necessary components in your source code. When your application is built, only the source code of the imported components (and their dependencies) will be included in the bundle.
Depending on which framework you use for your project, there are differences on how to set up the ES6 modules.
Usage in Create React App based applications
Prerequisites
To demonstrate the usage of the ES6 modules we will use the create-react-app to create an app.
The Mobiscroll source code can be downloaded from the download page, selecting the uncompressed version.
This guide assumes you have the create-react-app cli installed. If not, visit the Create React App github page on how to get started with the cli.
The following command will create the React app:
$ create-react-app my-app
After creating your app please make sure to install node-sass to ensure that your app supports scss. (starting from version 4.7.0 the Mobiscroll stylesheets are written in SCSS). You'll find more information about how can you install the node-sass module here.
Setting up the App
After the app is createad, the js, scss and fonts folders have to be extracted and copied over from the downloaded package to the src/lib/mobiscroll folder of your app.
Make sure the existing folder structure is kept. Here's how the app structure should look after the setup:
/
|--node_modules
|--public
|--src
|--lib
|--mobiscroll
|--fonts
|--js
|--scss
|--App.js
|--App.scss
|--index.js
|--index.scss
|--package.json
*Above are shown only the files and folders that are most relevant to this guide.
For example, to use the calendar component in the App.js, the mobiscroll variable has to be imported to that component. Also the related component styles needed to be imported as well. The same is true for the Form and any other Mobiscroll component. Here's how to load both components:
import React from 'react';
// import Calendar and Form components
import mobiscroll from './lib/mobiscroll/js/calendar.react.jsx';
import './lib/mobiscroll/js/forms.react.jsx';
// Import themes
import './lib/mobiscroll/js/themes/material';
import './lib/mobiscroll/js/themes/material-dark';
import './lib/mobiscroll/js/themes/ios';
import './lib/mobiscroll/js/themes/ios-dark';
import './lib/mobiscroll/js/themes/auto-theme';
// Import languages
import './lib/mobiscroll/js/i18n/de';
import './lib/mobiscroll/js/i18n/es';
import './lib/mobiscroll/js/i18n/zh';
import './App.scss';
function App() {
return (
<div className="App">
<mobiscroll.Form>
<label>
Birthday
<mobiscroll.Calendar theme="auto" />
</label>
</mobiscroll.Form>
</div>
);
}
export default App;
The icons required for the package are located in the fonts folder. There's an scss variable that needs to be set to find the font, and it's called $mbsc-font-path.
/* Set the font path first */
$mbsc-font-path: '../../fonts/';
/* Import Mobiscroll component styles for each theme */
@import './lib/mobiscroll/scss/calendar/calendar.mobiscroll';
@import './lib/mobiscroll/scss/calendar/calendar.material.scss';
@import './lib/mobiscroll/scss/calendar/calendar.ios';
@import './lib/mobiscroll/scss/forms/forms.mobiscroll';
@import './lib/mobiscroll/scss/forms/forms.ios';
@import './lib/mobiscroll/scss/forms/forms.material.scss';
At this point building and running the app, should work, and the mobiscroll components should show up using the default mobiscroll theme.
npm start
Usage in other React based applications
To demonstrate the usage of the ES6 modules we will use the following directory structure.
Copy the downloaded Mobiscroll source code to the lib/mobiscroll folder, making sure the
existing folder structure is kept.
/
|--dist/
|--bundle.js
|--bundle.css
|--js/
|--app.jsx
|--lib/
|--mobiscroll/
|--styles/
|--style.scss
|--index.html
|--.babelrc
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Mobiscroll</title>
<link href="dist/bundle.css" rel="stylesheet">
</head>
<body>
<div id="content"></div>
</body>
</html>
Loading components
All components are located in the root of the Mobiscroll source code folder.
Every component exports the main mobiscroll object as default, so import the main mobiscroll object from any of the first loaded component. Subsequent components will be attached automatically to the main object.
Themes should be loaded from the themes folder of the Mobiscroll source.
To use the auto theme feature (choosing theme automatically based on platform) make sure to
import all themes for the platforms you'd like to support, after that import the auto-theme module.
Languages should be loaded from the i18n folder of the Mobiscroll source.
import React from 'react';
import ReactDOM from 'react-dom';
// Import components
import mobiscroll from '../lib/mobiscroll/js/datetime.react';
import '../lib/mobiscroll/js/forms.react';
// Import themes
import '../lib/mobiscroll/js/themes/material';
import '../lib/mobiscroll/js/themes/material-dark';
import '../lib/mobiscroll/js/themes/ios';
import '../lib/mobiscroll/js/themes/ios-dark';
import '../lib/mobiscroll/js/themes/auto-theme';
// Import languages
import '../lib/mobiscroll/js/i18n/de';
import '../lib/mobiscroll/js/i18n/es';
import './/lib/mobiscroll/js/i18n/zh';
class Form extends React.Component {
render() {
return (
<mobiscroll.Form theme="auto">
<div className="mbsc-form-group-inset">
<label>
Name
<input name="username" />
</label>
<label>
Email address
<input name="email" type="email" />
</label>
<label>
Password
<input name="password" type="password" data-password-toggle="true" />
</label>
<label>
Birthday
<mobiscroll.Date theme="auto" lang="es" />
</label>
</div>
<div className="mbsc-form-group-inset">
<button className="mbsc-btn-block" type="submit">Create account</button>
</div>
</mobiscroll.Form>
);
}
}
ReactDOM.render(
<Form />,
document.getElementById('content')
);
The above code needs to be transpiled to ES5 code in order to run in the browser. There are various module bundlers out there to help you with that. Read on to see how to do this with some of the popular module bundlers (webpack, Rollup, Browserify).
Loading styles
Styles are written in Sass and are also modular.
In our styles.scss file we import the themes for the components we're using.
/* Specify font icon path */
$mbsc-font-path: './fonts/';
/* Import required themes for each component */
@import '../lib/mobiscroll/scss/datetime/datetime.material.scss';
@import '../lib/mobiscroll/scss/forms/forms.material.scss';
@import '../lib/mobiscroll/scss/datetime/datetime.ios.scss';
@import '../lib/mobiscroll/scss/forms/forms.ios.scss';
/* Import custom themes */
@import "../mobiscroll/scss/themes/mobiscroll.scss"
@include mbsc-custom-theme('mobiscroll-red', 'mobiscroll', ('background': #f7f7f7, 'text': #454545, 'accent': #e61d2a));
Compiling the Sass styles to css might vary depending on the build system you're using for your app. If you're not using any yet, you can simply compile it from command line, assuming Sass is installed.
node-sass styles/style.scss dist/bundle.css
Some javascript module bundlers (like webpack or Rollup) support importing the styles in the javascript source code through plugins and extensions. See examples below.
Webpack
Install webpack
npm install --save-dev webpack webpack-cli
Install babel-loader to transpile ES6 code
npm install --save-dev babel-core babel-preset-es2015 babel-preset-react babel-loader@7
In this example we're using css-loader and sass-loader to import the styles directly in the
javascript source, the extract-text-webpack-plugin to bundle the styling in a separate css file,
and file-loader for the font icon files.
npm install --save-dev style-loader css-loader sass-loader file-loader node-sass extract-text-webpack-plugin@next
Import component files, theme files and the style file in the javascript source.
import React from 'react';
import ReactDOM from 'react-dom';
// Import components
import mobiscroll from '../lib/mobiscroll/js/datetime.react';
import '../lib/mobiscroll/js/forms.react';
// Import themes
import '../lib/mobiscroll/js/themes/material';
import '../lib/mobiscroll/js/themes/ios';
import '../lib/mobiscroll/js/themes/auto-theme';
// Import styles
import './styles/style.scss';
class Form extends React.Component {
render() {
return (
<mobiscroll.Form theme="auto">
<div className="mbsc-form-group-inset">
<label>
Name
<input name="username" />
</label>
<label>
Email address
<input name="email" type="email" />
</label>
<label>
Password
<input name="password" type="password" data-password-toggle="true" />
</label>
<label>
Birthday
<mobiscroll.Date theme="auto" />
</label>
</div>
<div className="mbsc-form-group-inset">
<button className="mbsc-btn-block" type="submit">Create account</button>
</div>
</mobiscroll.Form>
);
}
}
ReactDOM.render(
<Form />,
document.getElementById('content')
);
Import component styles in the style.scss file.
/* Specify font icon path */
$mbsc-font-path: './fonts/';
/* Import component styles */
@import '../lib/mobiscroll/scss/datetime.material.scss';
@import '../lib/mobiscroll/scss/forms.material.scss';
@import '../lib/mobiscroll/scss/datetime.ios.scss';
@import '../lib/mobiscroll/scss/forms.ios.scss';
Configuration file for webpack
var ExtractTextPlugin = require("extract-text-webpack-plugin");
module.exports = {
entry: './js/app.jsx',
output: {
filename: 'bundle.js',
},
module: {
rules: [{
test: /\.jsx$/,
exclude: /node_modules/,
use: 'babel-loader'
}, {
test: /\.css$/,
use: ExtractTextPlugin.extract(['css-loader'])
}, {
test: /\.scss/,
use: ExtractTextPlugin.extract(['css-loader', 'sass-loader'])
}, {
test: /.(png|woff(2)?|eot|ttf|svg)(\?[a-z0-9=\.]+)?$/,
use: 'file-loader'
}]
},
plugins: [
new ExtractTextPlugin('bundle.css')
]
};
We will also need the .babelrc configuration file in the project root.
{ "presets": [ "es2015", "react" ] }
Run webpack to create the bundles.
npx webpack
Rollup
Install Rollup
npm install --save-dev rollup rollup-plugin-commonjs rollup-plugin-node-resolve
Install rollup-plugin-babel and babel-preset-es2015-rollup to transpile ES2015 code.
npm install --save-dev rollup-plugin-babel rollup-plugin-replace babel-preset-es2015-rollup babel-preset-react
In this example we're using the rollup-plugin-sass plugin to be able
to import the styling in the javascript source.
npm install --save-dev rollup-plugin-sass
Import component files, theme files and the style file in the javascript source.
import React from 'react';
import ReactDOM from 'react-dom';
// Import components
import mobiscroll from '../lib/mobiscroll/js/datetime.react';
import '../lib/mobiscroll/js/forms.react';
// Import themes
import '../lib/mobiscroll/js/themes/material';
import '../lib/mobiscroll/js/themes/ios';
import '../lib/mobiscroll/js/themes/auto-theme';
// Import styles
import './styles/style.scss';
class Form extends React.Component {
render() {
return (
<mobiscroll.Form theme="auto">
<div className="mbsc-form-group-inset">
<label>
Name
<input name="username" />
</label>
<label>
Email address
<input name="email" type="email" />
</label>
<label>
Password
<input name="password" type="password" data-password-toggle="true" />
</label>
<label>
Birthday
<mobiscroll.Date theme="auto" />
</label>
</div>
<div className="mbsc-form-group-inset">
<button className="mbsc-btn-block" type="submit">Create account</button>
</div>
</mobiscroll.Form>
);
}
}
ReactDOM.render(
<Form />,
document.getElementById('content')
);
Import component styles in the style.scss file.
/* Specify font icon path */
$mbsc-font-path: './fonts/';
/* Import component styles */
@import '../lib/mobiscroll/scss/datetime.material.scss';
@import '../lib/mobiscroll/scss/forms.material.scss';
@import '../lib/mobiscroll/scss/datetime.ios.scss';
@import '../lib/mobiscroll/scss/forms.ios.scss';
Configuration file for Rollup
import sass from 'rollup-plugin-sass';
import babel from 'rollup-plugin-babel';
import commonjs from 'rollup-plugin-commonjs';
import nodeResolve from 'rollup-plugin-node-resolve';
import replace from 'rollup-plugin-replace';
export default {
entry: 'js/app.jsx',
dest: 'dist/bundle.js',
format: 'iife',
plugins: [
nodeResolve({
jsnext: true
}),
replace({
'process.env.NODE_ENV': JSON.stringify('production')
}),
commonjs({
include: 'node_modules/**'
}),
sass({
output: 'dist/bundle.css'
}),
babel({
exclude: 'node_modules/**'
})
]
};
We will also need the .babelrc configuration file in the project root.
{ "presets": [ "es2015-rollup", "react" ] }
Run Rollup to create the bundles, using the -c option to use the configuration file.
./node_modules/.bin/rollup -c
Browserify
Install Browserify
npm install --save-dev browserify
Install babelify and babel-preset-es2015 to transpile ES2015 code.
npm install --save-dev babel-preset-es2015 babel-preset-react babelify
We will also need the .babelrc configuration file in the project root.
{ "presets": [ "es2015", "react" ] }
Run Browserify to create the bundles
./node_module/.bin/browserify js/app.js -t babelify --outfile dist/bundle.js